//+------------------------------------------------------------------+
//|                                              X2MA_HTF_Signal.mq5 |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru |
//+------------------------------------------------------------------+
//|     SmoothAlgorithms.mqh                  |
//|    : __\MQL5\Include  |
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2010, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//---   
#property version   "1.60"
//+----------------------------------------------+ 
//|                  |
//+----------------------------------------------+ 
//---     
#property indicator_chart_window 
#property indicator_buffers 1
#property indicator_plots   1
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET  0 //        
//+-----------------------------------+    
//|          |
//+-----------------------------------+    
#include <SmoothAlgorithms.mqh>
//+-----------------------------------+
//|             |
//+-----------------------------------+
enum APPLIED_PRICE //  
  {
   PRICE_CLOSE_ = 1,     // Close
   PRICE_OPEN_,          // Open
   PRICE_HIGH_,          // High
   PRICE_LOW_,           // Low
   PRICE_MEDIAN_,        // Median Price (HL/2)
   PRICE_TYPICAL_,       // Typical Price (HLC/3)
   PRICE_WEIGHTED_,      // Weighted Close (HLCC/4)
   PRICE_SIMPLE,         // Simple Price (OC/2)
   PRICE_QUARTER_,       // Quarted Price (HLOC/4) 
   PRICE_TRENDFOLLOW0_,  // TrendFollow_1 Price 
   PRICE_TRENDFOLLOW1_   // TrendFollow_2 Price 
  };
//+-----------------------------------+
//|         |
//+-----------------------------------+
input string Symbol_="";                   //  
input ENUM_TIMEFRAMES Timeframe=PERIOD_H6; //     
input Smooth_Method MA_Method1=MODE_SMA;   //     
input int Length1=12;                      //                       
input int Phase1=15;                       //   
input Smooth_Method MA_Method2=MODE_JJMA;  //     
input int Length2 = 5;                     //     
input int Phase2=15;                       //   ,
input APPLIED_PRICE IPC=PRICE_CLOSE;       //  
input int Shift=0;                         //      
input int PriceShift=0;                    //      
//---   
input string Symbols_Sirname="X2MA_Label_";//    
input color UpSymbol_Color=Blue;           //   
input color DnSymbol_Color=Red;            //   
input color IndName_Color=DarkOrchid;      //   
input uint Symbols_Size=34;                //   
input uint Font_Size=15;                   //    
input int X_3=120;                         //    
input int Y_3=10;                          //    
input bool ShowIndName=true;               //   
input ENUM_BASE_CORNER  WhatCorner=CORNER_RIGHT_UPPER; //  
input uint X_=0;                           //   
input uint Y_=0;                           //   
//+-----------------------------------+
//---      
int X2MA_Handle;
//---      
int min_rates_total;
//---         
uint X_0,X_1,X_2,X_3_,Yn,Y_3_;
//---     
string name0,name1,name2,name3,IndName,Symb;
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
string GetStringTimeframe(ENUM_TIMEFRAMES timeframe)
  {
   return(StringSubstr(EnumToString(timeframe),7,-1));
  }
//+------------------------------------------------------------------+
//|                                            |
//+------------------------------------------------------------------+
void CreateTLabel(long   chart_id,         //  
                  string name,             //  
                  int    nwin,             //  
                  ENUM_BASE_CORNER corner, //   
                  ENUM_ANCHOR_POINT point, //   
                  int    X,                //      X   
                  int    Y,                //      Y   
                  string text,             // 
                  color  Color,            //  
                  string Font,             //  
                  int    Size)             //  
  {
//---
   ObjectCreate(chart_id,name,OBJ_LABEL,0,0,0);
   ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);
   ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,point);
   ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,X);
   ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,Y);
   ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
   ObjectSetInteger(chart_id,name,OBJPROP_COLOR,Color);
   ObjectSetString(chart_id,name,OBJPROP_FONT,Font);
   ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,Size);
   ObjectSetInteger(chart_id,name,OBJPROP_BACK,true);
//---
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
void SetTLabel(long   chart_id,         //  
               string name,             //  
               int    nwin,             //  
               ENUM_BASE_CORNER corner, //   
               ENUM_ANCHOR_POINT point, //   
               int    X,                //      X   
               int    Y,                //      Y   
               string text,             // 
               color  Color,            //  
               string Font,             //  
               int    Size)             //  
  {
//---
   if(ObjectFind(chart_id,name)==-1) CreateTLabel(chart_id,name,nwin,corner,point,X,Y,text,Color,Font,Size);
   else
     {
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,X);
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,Y);
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,Color);
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,Size);
     }
//---
  }
//+------------------------------------------------------------------+    
//| X2MA indicator initialization function                           | 
//+------------------------------------------------------------------+  
int OnInit()
  {
//---    CXMA   SmoothAlgorithms.mqh
   CXMA XMA;
//---     
   int min_rates_total1=XMA.GetStartBars(MA_Method1, Length1, Phase1);
   int min_rates_total2=XMA.GetStartBars(MA_Method2, Length2, Phase2);
   min_rates_total=min_rates_total1+min_rates_total2+4;
//---  
   if(Symbol_!="") Symb=Symbol_;
   else Symb=Symbol();
//---
   X_0=X_;
   X_1=uint(X_0+Symbols_Size*1.1);
   X_2=uint(X_1+Symbols_Size*1.1);
   Yn=Y_+5;
//---
   name0=Symbols_Sirname+"0";
   name1=Symbols_Sirname+"1";
   name2=Symbols_Sirname+"2";
   if(ShowIndName)
     {
      Y_3_=Yn+Y_3;
      X_3_=X_0+X_3;
      name3=Symbols_Sirname+"3";
      StringConcatenate(IndName,"X2MA(",Symb," ",GetStringTimeframe(Timeframe),")");
     }
//---    X2MA
   X2MA_Handle=iCustom(Symb,Timeframe,"X2MA",MA_Method1,Length1,Phase1,MA_Method2,Length2,Phase2,IPC,0,0);
   if(X2MA_Handle==INVALID_HANDLE)
     {
      Print("      X2MA");
      return(INIT_FAILED);
     }
//---      
   string shortname;
   string Smooth1=XMA.GetString_MA_Method(MA_Method1);
   string Smooth2=XMA.GetString_MA_Method(MA_Method2);
   StringConcatenate(shortname,"X2MA(",Length1,", ",Length2,", ",Smooth1,", ",Smooth2,")");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+    
void Deinit()
  {
//---
   if(ObjectFind(0,name0)!=-1) ObjectDelete(0,name0);
   if(ObjectFind(0,name1)!=-1) ObjectDelete(0,name1);
   if(ObjectFind(0,name2)!=-1) ObjectDelete(0,name2);
   if(ObjectFind(0,name3)!=-1) ObjectDelete(0,name3);
//---
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+    
void OnDeinit(const int reason)
  {
//---
   Deinit();
//---
   ChartRedraw(0);
  }
//+------------------------------------------------------------------+  
//| X2MA iteration function                                          | 
//+------------------------------------------------------------------+  
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(BarsCalculated(X2MA_Handle)<min_rates_total) return(RESET);
   if(BarsCalculated(X2MA_Handle)<Bars(Symb,Timeframe)) return(prev_calculated);
//---   
   int to_copy=4;
   double dx2ma0,dx2ma1,dx2ma2;
   double X2MA[4];
   color Color0,Color1,Color2;
//---      
   if(CopyBuffer(X2MA_Handle,0,0,to_copy,X2MA)<=0) return(RESET);
//---
   dx2ma0=X2MA[3]-X2MA[2];
   dx2ma1=X2MA[2]-X2MA[1];
   dx2ma2=X2MA[1]-X2MA[0];
//---
   if(dx2ma0<0) Color0=DnSymbol_Color; else Color0=UpSymbol_Color;
   if(dx2ma1<0) Color1=DnSymbol_Color; else Color1=UpSymbol_Color;
   if(dx2ma2<0) Color2=DnSymbol_Color; else Color2=UpSymbol_Color;
//---
   SetTLabel(0,name0,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_0,Yn,"t",Color0,"Wingdings 2",Symbols_Size);
   SetTLabel(0,name1,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_1,Yn,"u",Color1,"Wingdings 2",Symbols_Size);
   SetTLabel(0,name2,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_2,Yn,"v",Color2,"Wingdings 2",Symbols_Size);
   if(ShowIndName) SetTLabel(0,name3,0,WhatCorner,ENUM_ANCHOR_POINT(2*WhatCorner),X_3_,Y_3_,IndName,IndName_Color,"Georgia",Font_Size);
//---
   ChartRedraw(0);
//---
   return(rates_total);
  }
//+------------------------------------------------------------------+
